### Method

# Gck Builder add_data

#### Declaration [src]

    void
    gck_builder_add_data (
      GckBuilder* builder,
      gulong attr_type,
      const guchar* value,
      gsize length
    )

#### Description [src]

Add a new attribute to the builder with an arbitrary value. Unconditionally adds a new attribute, even if one with the same `attr_type` already exists.

The memory in `value` is copied by the builder.

`NULL` may be specified for the `value` argument, in which case an empty attribute is created. `GCK_INVALID` may be specified for the length, in which case an invalid attribute is created in the PKCS#11 style.

#### Parameters

`attr_type`

  Type: `gulong`

  The new attribute type.

`value`

  Type: An array of `guchar`

  The new attribute memory.

  The argument can be `NULL`.
  The length of the array is specified in the `length` argument.
  The data is owned by the caller of the function.

`length`

  Type: `gsize`

  The length of the memory.